import itertools
import os

import pandas as pd
import numpy as np
from standard_precip import spi



def year(group, col='date'):
    return group[col].dt.year


def dry(group, col='rain_calculated_index'):
    rain = group[col]
    return rain <= -1.5


df_sta = pd.read_csv(r'H:\CMIP6\china_stations.csv', encoding='ANSI')
# 选取站点号数据
number = df_sta['sta']
ss = np.array(number)

# 构造时间
date = pd.date_range('1961-1-1', periods=51134, freq='D')
df_date = pd.DataFrame(date, columns=['date'])

path = r'E:\CMIP6\S245\\'
print('\n')
data = []
index = 0
df1 = pd.read_excel(r'E:\CMIP6\S245.xlsx')
df1 = df1.drop(columns=[df1.keys()[0]])

for i in range(len(number)):
    # 读取数据
    str(ss[i])
    # print(ss[i])
    # if ss[i] != 51477:
    #     continue
    file = path + str(ss[i]) + '_S245.xlsx'
    if os.path.exists(file):
        row = [ss[i]]
        df = pd.read_excel(file)
        # df_precip = pd.DataFrame(df['rain'],columns=['precip'])
        df_day = pd.concat([df_date, df], axis=1)
        spi_daily = spi.SPI()
        try:
            #df_spi_daily = spi_daily.calculate(df_day, 'date', ['rain'], freq="D", scale=1,
                                              # fit_type="lmom", dist_type="gam")
            print('******************************' + str(ss[i]) + '******************************')
            # df_spi_year = df_spi_daily.groupby('date').apply(year)
            #df_spi_year = pd.concat([df_day, df_spi_daily], axis=1)
            df_year = df_day.groupby('year')
            # print(df_year)
            # 一个站点2020-2050所有年份的干旱天数
            dry_days_of_per_year = [0]
            for year, row in df_year:
                if 2020 <= year <= 2050:
                    items, counts = [True], [0]
                    drys = row['rain'][90:275].apply(lambda i: i <= 1)
                    for key, val in itertools.groupby(np.array(drys)):
                        if key:
                            items.append(key)
                            counts.append(len(list(val)))
                    dry_days_of_per_year.append(np.array(counts).max())
            # drys = df_year.apply(dry)
            np_array = np.array(dry_days_of_per_year)
            #print(np_array)
            # 年均干旱天数 = 31年干旱天数总和/31
            ave_dry_day = np_array.sum()/31
            # 干旱天数大于15的年份
            filter = np.where(np_array >= 15)
            # 每年发生连续15日以上干旱概率(%) = 干旱天数大于15的年份数量/31
            p_of_dry = filter[0].__len__() / 31
            print([ss[i], ave_dry_day, p_of_dry*100])
            data.append([ss[i], ave_dry_day, p_of_dry*100])
        except ValueError as e:
            print(ss[i])
            print("计算异常", e)
        index = index + 1
        # if index > 5:
        #     break
df_dry = pd.DataFrame(data=data, columns=['站点', '年均连续干旱日数(天)', '每年发生连续15日以上干旱概率(%)'])
merge = pd.merge(left=df1, right=df_dry, how='left', on='站点', left_index=False, sort=True)
writer = pd.ExcelWriter('S245_0928_4_9.xlsx')  # 写入Excel文件
merge.to_excel(writer, 'S245', float_format='%.5f', index=None)  # ‘page_1’是写入excel的sheet名
writer.save()
writer.close()
